angular.module('siggo')
  .controller('AccountPreferencesCtrl', function($scope, AccountPreferences) {

    AccountPreferences.getCategories()
      .then(function(res) {
        $scope.categories = res;
        console.log(res);
      }, function(status) {});


    $scope.changeCategory = function() {
      AccountPreferences.putCategories($scope.categories)
        .then(function(res) {
          console.log(res);
        }, function(status) {
          // effect 100ms
          setTimeout(function() {
            $scope.categories = AccountPreferences.localCategories();
          }, 100);
        });
    }


    $scope.changeAccessibility = function() {
      AccountPreferences.putAccessibility($scope.accessibility)
        .then(function(res) {
          console.log(res);
        }, function(status) {
          // effect 100ms
          setTimeout(function() {
            $scope.accessibility = AccountPreferences.localAccessibility();
          }, 100);
        });
    }


    AccountPreferences.getAccessibility()
      .then(function(res) {
        $scope.accessibility = res;
      }, function(status) {});



      $scope.changePayment = function() {
        AccountPreferences.putPayment($scope.payment)
          .then(function(res) {
            console.log(res);
          }, function(status) {
            // effect 100ms
            setTimeout(function() {
              //$scope.accessibility = AccountPreferences.localAccessibility();
            }, 100);
          });
      }

    AccountPreferences.getPayment()
      .then(function(res) {
        $scope.payment = res;
      }, function(status) {});



  })
