angular.module('siggo')
  .controller('Inicio', function($log, $scope, $timeout, $interval, $animate, $cordovaMedia, $ionicPlatform, $ionicHistory,
    $ionicGesture, $document, $rootScope, Mensajes, $ionicViewSwitcher, $state, Socket, /*uiGmapGoogleMapApiManualLoader,*/
    Mapa, $cordovaAppVersion, DeviceStatusService, deviceConfiguration, $ionicPopup,
    User, $cordovaVibration, $$flashlight, AccountPreferences, Services, WaitClientConfirmationModal,
    Emergency, toaster, TravelSummaryModal,VehiclesListModal,ServiceInformationModal,ServiceConfirmationModal,ServiceCancelModal,

    /*required for initial load*/
    News, Requirements, AccountPreferences, DeviceSettingsMonitor, MessengerReceiver
  ) {


    // adquiere ultimo veiculo uzado

    // Lista vehiculos
    $scope.vehiculos = [];


    // guarda el formato de pago para viaje
    $scope.pagoFormato = {};


/*    $scope.CargaListaVehiculos = function() {
      $log.log('Inicio: $scope.CargaListaVehiculos');
      $scope.cargandoLugares = true;
      User.getVehiclesList()
        .then(function(res) {
          $scope.vehiculos = res;
          $scope.cargandoLugares = false;
        }, function(status) {
          Mensajes.alert('js.controllers.inicio.title', 'js.controllers.inicio.text', function() {
            Mensajes.hideModal();
          });
        });
      //Socket.on("vehiculos_lista", $scope.ListaVehiculos);
      //Socket.emit("vehiculos_lista");
    }*/

    // conductor_estado comprobe que deveria in en post para evitar problemas
/*    $scope.seleccionaVehiculo = function(vehiculo) {
      Mensajes.showLoading('js.controllers.inicio.connecting');
      User.connectVehicle(vehiculo.IdVehiculo, vehiculo.Categoria)
        .then(function(res) {
          $rootScope.vehicleOnline = true;
          Mensajes.hideModal();
          Mensajes.hideLoading();

          if (window.cordova)
            BackgroundGeolocation.start();

        }, function(status) {
          Mensajes.hideLoading();
        });

      //Socket.on("conductor_estado", $scope.conductorEstado);
      //Socket.emit("conductor_estado", {IdVehiculo: vehiculo.IdVehiculo, IdCategoria: vehiculo.Categoria});
    }*/

    // fin lista vehiculos


    $ionicHistory.clearHistory();

    $scope.$on('$ionicView.beforeEnter', function() {
      console.log('.$on beforeEnter inicio');

      if (!$rootScope.Usuario) { // porque no podria existir $rootScope.Usuario???
        $ionicViewSwitcher.nextDirection('enter');
        $state.go("login");
      }

    });

    $scope.$on('$ionicView.afterEnter', function() {
      console.log('.$on afterEnter inicio');

      if ($rootScope.Usuario) {
        $timeout(function() {
          Socket.open($rootScope.Usuario.Token);
        }, 2000);
      }
    });

    if (!$rootScope.Usuario) {
      $ionicViewSwitcher.nextDirection('enter');
      $state.go("login");
    }

    $rootScope.conectar = function() {
      $log.log('Inicio: $rootScope.conectar');



      // cierra panel socio, ??? sigue??
      if ($state.current.name != "app.inicio") {
        try {
          $rootScope.panelSocio.close();
          $rootScope.panelSocio = null;
        } catch (err) {}

        $ionicViewSwitcher.nextDirection('back');
        $state.go("app.inicio");
      }


      if ($rootScope.vehicleOnline == false) {
        /*Mensajes.showModal("screens/modals/vehiculos.html", "", $scope);*/
        VehiclesListModal.show();
/*        $scope.CargaListaVehiculos();
*/
      } else {
        Mensajes.showLoading('js.controllers.inicio.disconnecting');
        User.disconnectVehicle()
          .then(function(res) {
            $rootScope.vehicleOnline = false;
            Mensajes.hideLoading();
            if (window.cordova)
              BackgroundGeolocation.stop();
          }, function(status) {
            Mensajes.hideLoading();
          });

        // desactiva timer para informar status
        //DeviceStatusService.stopTimerOnline();
      }
    }

    $rootScope.$watch("vehicleOnline", function(newVal, oldVal) {
      console.log('$watch vehicleOnline inicio');

      //if (newVal == oldVal) return; paar probar!


      if (newVal) {
        if (window.cordova) {
          try {
            window.plugins.insomnia.keepAwake();
          } catch (e) {}

          document.addEventListener('deviceready', function() {
            //window.hello.conexion(true);
            Socket.open($rootScope.Usuario.Token);

            // desactiva timer para informar status
            DeviceStatusService.startTimerOnline();

          });
          Mapa.startBgGeo();
        }
      } else {
        if (window.cordova) {
          document.addEventListener('deviceready', function() {
            //window.hello.conexion(false);
            Socket.close();

            // desactiva timer para informar status
            DeviceStatusService.stopTimerOnline();
          });

          try {
            window.plugins.insomnia.allowSleepAgain();
          } catch (e) {}

          //Mapa.stop();
        }
      }
    });

    var mediaViaje;
    var mediaDestino;



    /*$scope.AlertaViaje = function() {
      console.log("tilin");
      if (mediaViaje) mediaViaje.play();

      var accessibility = AccountPreferences.localAccessibility();
      if (!accessibility) return;
      if (window.cordova && accessibility.deaf) {
        //$cordovaVibration.vibrate([300, 150, 300, 150, 1000]);
        //$$flashlight.flash([300, 150, 300, 150, 1000]);
        $cordovaVibration.vibrate(1500);
        $$flashlight.flash(1500);
      }

    };*/

    $scope.AlertaDestino = function() {
      if (deviceConfiguration.platform != "explorador") {
        if (!mediaDestino) {
          mediaDestino = $cordovaMedia.newMedia(deviceConfiguration.urlDestino,
            function(status) {
              console.log("media: ", status);
            },
            function(err) {
              console.log("media: ", err);
            });
        }
        mediaDestino.play();
      }
    };

    // conductor_estado_revisa
    $scope.EstadoInicial = function(data) {
      console.log('.on conductor_estado_revisa');
      if (data.Conductor) {
        $timeout(function() {
          $rootScope.vehicleOnline = data.Conductor.Status == 1;
          $rootScope.statusViaje = data.Conductor.StatusViaje;
        }, 1);

        if (data.Conductor.StatusViaje > 0) {
          Services.current()
            .then(function(res) {
              console.log(res);
              datosCliente(res);
            }, function(status) {
              console.error(status);
            });
        }

        if (data.Conductor.Status == 1) {
          if (window.cordova)
            BackgroundGeolocation.start();
        }

      }

      Mensajes.hideLoading();
    }

    $scope.primeravez = function() {
      $log.log('Inicio: $scope.primeravez');
      $scope.iniciado = true;

      User.getInfo()
        .then(function(res) {
          angular.extend($rootScope.Usuario, res);
        }, function(status) {});

      Mensajes.hideModal();

      // verifica si esta activo mock location
      if (window.cordova && !window.debug && deviceConfiguration.platform == "android")
        window.plugins.mocklocation.check(successCallback, errorCallback);
    }


    //  var a = true;
    $scope.$on("socket_connected", function(data) {
      console.log('.$on socket_connected');

      //$rootScope.$broadcast("socket_connected");
      //Socket.off("function_execute", $scope.ejecutaFuncion);
      //Socket.on("function_execute", $scope.ejecutaFuncion);
      $timeout(function() {
        if (navigator.splashscreen) navigator.splashscreen.hide();
        if (!$scope.iniciado) $scope.primeravez();
        //if (a) {
        //uiGmapGoogleMapApiManualLoader.load();
        //  a = false;
        //}
        Mensajes.showLoading('Revisando...');
        $log.log('conductor_estado_revisa');
        Socket.off("conductor_estado_revisa", $scope.EstadoInicial);
        Socket.on("conductor_estado_revisa", $scope.EstadoInicial);
        Socket.emit("conductor_estado_revisa");

        Socket.off("solicitud_viaje", $scope.SolicitudViaje);
        Socket.on("solicitud_viaje", $scope.SolicitudViaje);

        Socket.off("peticion_viaje", $scope.PeticionViaje);
        Socket.on("peticion_viaje", $scope.PeticionViaje);
        Socket.off("peticion_cancelada", $scope.PeticionCancelada);
        Socket.on("peticion_cancelada", $scope.PeticionCancelada);

        Socket.off("cancelar_viaje", $scope.ViajeCancelado);
        Socket.on("cancelar_viaje", $scope.ViajeCancelado);

        Socket.on("wait_confirm", function() {
          console.log('.on wait_confirm');
          //$rootScope.PeticionActiva = false; // permite abrir el modal
          Mensajes.hideModal();
          $interval.cancel(PB);
          WaitClientConfirmationModal.show();
        });
        Socket.on("request_rejected", function() {
          console.log('.on request_rejected');
          WaitClientConfirmationModal.hide();
          Mensajes.alert("js.controllers.inicio.service.cancel.title", "js.controllers.inicio.service.cancel.text");

        });





        if (window.cordova)
          $cordovaAppVersion.getVersionNumber().then(function(version) {
            Socket.emit("actualiza_version", {
              Version: version
            });
          });
      }, 1);
    });

    $rootScope.Viaje = {
      Cancelado: false,
      Pago: 1,
      Calificacion: 5,
      Comentarios: "",
      Total: 0,
      extraFee: 0,
      Efectivo: "",
      Descuento: 0,
      Pagar: 0,
      Origen: {
        latitude: null,
        longitude: null,
      },
      Destino: {
        latitude: null,
        longitude: null
      },
      OrigenTexto: "",
      DestinoTexto: "",
      IdServicio: 0,
      IdCliente: 0,
      Status: 0,
      Cliente: {
        Nombre: "",
        Telefono: "",
        //Facebook: "",
        Id: 0,
      }

    }

    // !!!: to prevent double modal error because large requests
    var solicitudViajeModalShowed = false;

    var datosCliente = function(data) {
      if (solicitudViajeModalShowed == true) return;
      $log.log('Inicio: $scope.datosCliente');
      if (data) {

        // extrae forma de pago
        $scope.pagoFormato.metodoPago = data.posicion.MetodoPago;
        $scope.pagoFormato.idCodigo = data.posicion.IdCodigo;

        // XXX: aveces no esta listo google
        var bnds = new google.maps.LatLngBounds();


        $rootScope.Viaje.Cliente = data.Cliente;
        $rootScope.Viaje.Cliente.Id = data.Conductor.IdCliente;

        $rootScope.Viaje.Origen = {
          latitude: data.posicion.OrigenLatitud,
          longitude: data.posicion.OrigenLongitud
        };
        $rootScope.Marcadores[0].posicion = $rootScope.Viaje.Origen;

        $rootScope.Viaje.Destino = {
          latitude: data.posicion.DestinoLatitud,
          longitude: data.posicion.DestinoLongitud
        };
        $rootScope.Marcadores[1].posicion = $rootScope.Viaje.Destino;

        $rootScope.Marcadores[0].options.visible = true;

        bnds.extend(new google.maps.LatLng(data.posicion.OrigenLatitud, data.posicion.OrigenLongitud));
        var geocoder = new google.maps.Geocoder();
        geocoder.geocode({
          'location': new google.maps.LatLng(data.posicion.OrigenLatitud, data.posicion.OrigenLongitud)
        }, function(results, status) {
          if (status === google.maps.GeocoderStatus.OK) {
            $rootScope.Viaje.OrigenTexto = results[0].formatted_address;
            $rootScope.$apply();
          }
        });

        if (data.posicion.DestinoLatitud && data.posicion.DestinoLatitud != 0) {
          $rootScope.Marcadores[1].options.visible = true;
          bnds.extend(new google.maps.LatLng(data.posicion.DestinoLatitud, data.posicion.DestinoLongitud));
          geocoder.geocode({
            'location': new google.maps.LatLng(data.posicion.DestinoLatitud, data.posicion.DestinoLongitud)
          }, function(results, status) {
            if (status === google.maps.GeocoderStatus.OK) {
              $rootScope.Viaje.DestinoTexto = results[0].formatted_address;
              $rootScope.$apply();
            }
          });
        } else {
          $rootScope.Viaje.DestinoTexto = "Sin definir";
        }

        bnds.extend(new google.maps.LatLng($rootScope.mapa.ubicacion.posicion.latitude, $rootScope.mapa.ubicacion.posicion.longitude));
        Mapa.zoomLimites(bnds);

        // deveria ser Service en ves de conductor
        $rootScope.Viaje.Conductor = data.Conductor;
        $rootScope.statusViaje = data.Conductor.StatusViaje;

        console.log('showModal solicitudViaje in datosCliente');
        if($state.current.name =="app.inicio") ServiceInformationModal.show($rootScope.Viaje,$scope.pagoFormato);
        // Mensajes.showModal("screens/modals/solicitudViaje.html", "", $scope);
        // !!!: to prevent double modal error because large requests
        solicitudViajeModalShowed = true;
        setTimeout(function(){solicitudViajeModalShowed = false; },1000);


        Socket.off("cliente_cambia_destino", $scope.CambiaDestino);
        Socket.on("cliente_cambia_destino", $scope.CambiaDestino);
      }

    }

    //Mensajes.showModal("screens/modals/solicitudViaje.html","",$scope);
    $scope.CambiaDestino = function(posicion) {
      console.log('.on cliente_cambia_destino');
      if (posicion.Posicion) {
        $rootScope.Marcadores[1].options.visible = true;
        $rootScope.Marcadores[1].posicion = {
          latitude: posicion.Posicion.latitude,
          longitude: posicion.Posicion.longitude
        };
        var bnds = $rootScope.mapa.getGMap().getBounds();
        bnds.extend(new google.maps.LatLng(posicion.Posicion.latitude, posicion.Posicion.longitude));

        Mapa.zoomLimites(bnds);
        //$rootScope.mapa.getGMap().fitBounds(bnds);

        $rootScope.Viaje.DestinoTexto = posicion.Posicion.DestinoNombre;
        $scope.AlertaDestino();
      } else {
        $rootScope.Marcadores[1].options.visible = false;
        $rootScope.Marcadores[1].posicion = {
          latitude: null,
          longitude: null
        };
      }

    }


    $scope.ViajeCancelado = function(data) {
      console.log('.on cancelar_viaje');
      $rootScope.$broadcast("hide");
      $timeout(function() {
        $rootScope.statusViaje = 0;
        $rootScope.Viaje.OrigenTexto = "";
        Mapa.centrarUbicacion();
        Mensajes.alert('js.controllers.inicio.service.cancel.title', 'js.controllers.inicio.service.cancel.text', function() {});
      });
    }


    $rootScope.$watch("statusViaje", function() {
      console.log('$watch statusViaje inicio');
      switch ($rootScope.statusViaje) {
        case 0:
          $rootScope.Marcadores[0].options.visible = false;
          $rootScope.Marcadores[1].options.visible = false;
          //$rootScope.mapa.zoom=16;
          Mapa.centrarUbicacion();
          angular.element(document.getElementById("contenedor-mapa")).removeClass('en-viaje');
          break;
        case 1:
          angular.element(document.getElementById("contenedor-mapa")).addClass('en-viaje');
          //Mapa.centrarUbicacion();
          break;
        case 2:
          angular.element(document.getElementById("contenedor-mapa")).addClass('en-viaje');
          Mapa.centrarUbicacion();
          break;
      }
    });


    $rootScope.PeticionActiva = false; // peticion activa

    $scope.Cliente = {};

    var PB;
    //var Tono;
    var Temporizador;
    var x = 0;
    var toAceptarViaje;
    var toPeticionCancelada;
    //var P eticionActiva = false;
    $scope.ImagenPB = '';
    $scope.Contador = 100;


    $scope.PeticionViaje = function(data) {
      console.log('.on peticion_viaje');
      if ($rootScope.PeticionActiva) return;

      //permite en explorador
      if (deviceConfiguration.platform != "explorador") {
        if (!mediaViaje) {
          mediaViaje = $cordovaMedia.newMedia(deviceConfiguration.urlViaje);
          console.log(mediaViaje);
        }
        mediaViaje.setVolume('1.0');
      }

      //Arreglo para evitar bloqueo en peticion desde otro State
      if ($state.current.name != "app.inicio") {
        try {
          $rootScope.panelSocio.close();
          $rootScope.panelSocio = null;
        } catch (err) {}

        console.log("entro aqui , debe cerrar el menu..................");

        $ionicViewSwitcher.nextDirection('back');
        $state.go("app.inicio");
      }

      // first show modal and then  active the petition.
      ServiceConfirmationModal.show(data);
      // Mensajes.showModal("screens/modals/confirmar-viaje.html", "", $scope);
      $rootScope.PeticionActiva = true;

      Socket.emit('recibir_peticion', {});
      $scope.Cliente = data;
      $scope.PDC = data.Id;


     /* x = 0;
      PB = $interval(function() {
        console.log('$interval PB inicio');

        x++;
        $scope.Contador = 100 - (x * 5);
        if (x % 3 == 0) $scope.AlertaViaje();
        if (x >= 20) {
          $scope.CancelarPeticion();
          // si no cancela el servidor cancela peticion local
          toPeticionCancelada = $timeout(function() {
            $scope.PeticionCancelada();
          }, 1000);
        }
      }, 1000);*/
    }






    // error y si no se cancela la peticion? ya se cerro el modal!!!
    $scope.$on('serviceRejected',function() {
      Socket.emit('cancelar_peticion', {});
    });

    // error y si no se cancela la peticion? ya se cerro el modal!!!
    $scope.PeticionCancelada = function() {
      console.log('.on peticion_cancelada');
      // restaura para poder AceptarViaje() y cerrar modal
      $rootScope.PeticionActiva = false;
      acceptRequestSent = false;
      $timeout.cancel(toAceptarViaje);

      // cancelar peticion
      //$interval.cancel(Tono);
      $interval.cancel(PB);
      $timeout.cancel(Temporizador);
      $timeout.cancel(toPeticionCancelada);
      Mensajes.hideModal();
    }





    // error fatal y si no se recibio respuesta de aceptar peticion
    var acceptRequestSent = false;
    $scope.$on('serviceAccepted', function() {
      if (acceptRequestSent) return;
      acceptRequestSent = true;

      //$rootScope.PeticionActiva = false;// porque aqui ??? creo quitar!!!

      Socket.emit('aceptar_peticion', $scope.Cliente);

      // en caso de que no se reciba respuesta de soket se cancela el bloqueo para aceptar viaje
      toAceptarViaje = $timeout(function() {
        $rootScope.PeticionActiva = false;
        acceptRequestSent = false;
      }, 1500);
    });


    $scope.SolicitudViaje = function(data) {
      console.log(".on solicitud_viaje");
      WaitClientConfirmationModal.hide();

      // restaura para poder AceptarViaje();
      $rootScope.PeticionActiva = false;
      acceptRequestSent = false;
      $timeout.cancel(toAceptarViaje);


      //$interval.cancel(Tono);
      $interval.cancel(PB);
      $timeout.cancel(Temporizador);
      Mensajes.hideModal();
      $scope.statusViaje = 1;





      //solicitud de viaje
      /* ***** I think this isnt needed because now exists travel-summary
      $rootScope.Viaje.Cancelado = false; // ???: this is necesary. is inside travel-summary
      $rootScope.Viaje.Calificacion = 5; // ???: this is necesary. is inside travel-summary
      $rootScope.Viaje.Comentarios = ""; // ???: this is necesary. is inside travel-summary
      $rootScope.Viaje.Efectivo = ""; // ???: this is necesary. is inside travel-summary, and "" will be 0
      */

      $rootScope.Viaje.IdServicio = data.IdServicio; // ???: this is necesary. is inside travel-summary
      $rootScope.Viaje.IdCliente = data.Id;
      $rootScope.Viaje.Cliente = null;
      $rootScope.Viaje.OrigenTexto = "";
      $rootScope.Viaje.Origen = {
        latitude: null,
        longitude: null
      };
      $rootScope.Viaje.DestinoTexto = "";
      $rootScope.Viaje.Destino = {
        latitude: null,
        longitude: null
      };

      Services.current()
        .then(function(res) {
          console.log(res);
          datosCliente(res);
        }, function(status) {
          console.error(status);
        });
    }


    $rootScope.CancelarViaje = function() {
      ServiceCancelModal.show();
    }

    $scope.MostrarViaje = function() {
      ServiceInformationModal.show($rootScope.Viaje,$scope.pagoFormato);
    }



    $scope.cargandoLugares = true;

    $scope.LlamarCliente = function() {
      $log.log('Inicio: $scope.LlamarCliente', $rootScope.Viaje.Cliente.Telefono);
      if (window.cordova)
        cordova.InAppBrowser.open('tel:' + $rootScope.Viaje.Cliente.Telefono, "_system");
    }


    $scope.ViajeIniciado = function(data) {
      console.log('.on iniciar_viaje');
      if (data.Error) {
        toaster.pop({
          type: 'error',
          title: $filter('translate')('js.controllers.inicio.no-start.title'),
          body: $filter('translate')('js.controllers.inicio.no-start.text'),
          timeout: 5000
        });
        return;
      }
      $timeout(function() {
        $rootScope.statusViaje = 2;
      }, 5);
    }


    $scope.ViajeTerminado = function(data) {
      console.log('.on terminar_viaje')
      clearTimeout(toLoadingEndTravel);
      Mensajes.hideLoading();

      Socket.off("terminar_viaje", $scope.ViajeTerminad);
      TravelSummaryModal.show(data)
    }

    var toLoadingEndTravel;
    $rootScope.FinalizarViaje = function() {
      $log.log('Inicio: $rootScope.FinalizarViaje');
      Mensajes.showLoading('js.controllers.inicio.service.ending');
      Socket.on("terminar_viaje", $scope.ViajeTerminado);
      Socket.emit("terminar_viaje");


      // por si hay error de comunicacion socket por tiempo se cancela loading
      toLoadingEndTravel = setTimeout(function() {
        // por default funciona para no cancelar en alarma activada
        toaster.pop({
          type: 'error',
          title: $filter('translate')('js.controllers.inicio.service.no-cancel.title'),
          body: $filter('translate')('js.controllers.inicio.service.no-cancel.text'),
          timeout: 5000
        });

        Mensajes.hideLoading();
      }, 10000);
    }

    $rootScope.IniciarViaje = function() {
      $log.log('Inicio: $rootScope.IniciarViaje');
      Mensajes.confirm("js.controllers.inicio.service.start-confirm.title", "js.controllers.inicio.service.start-confirm.text", function(data) {
        Socket.on("iniciar_viaje", $scope.ViajeIniciado);
        Socket.emit("iniciar_viaje");
      });
    }



    // ceck mock location status

    var mockCheckInterval;




    document.addEventListener("resume", function() {
      if (window.cordova && !window.debug && deviceConfiguration.platform == "android")
        window.plugins.mocklocation.check(successCallback, errorCallback);
    }, false);






    function successCallback(enabled) {
      console.log("mocklocation enabled: ", enabled); // true - enabled, false - disabled
      if (eval(enabled)) {

        if (buttonLocked) setTimeout(function() {
          buttonLocked = false;
        }, 1000);
        if (myPopup) return;


        showPopup();

        mockCheckInterval = setInterval(function() {
          console.log('setInterval mockCheckInterval inicio');
          Socket.emit("mocklocation_enabled");
        }, 3000);

      } else {
        clearInterval(mockCheckInterval);
        closePopup();
        buttonLocked = false;
      }
    }

    function errorCallback(error) {
      console.log("mocklocation error: ", error);
      setTimeout(function() {
        window.plugins.mocklocation.check(successCallback, errorCallback);
      }, 1000);
    }





    /* INICIO MOCKLOCATION MODAL
     */

    var myPopup = null;
    var buttonLocked = false;

    var showPopup = function() {

      myPopup = $ionicPopup.show({
        template: $filter('translate')('js.controllers.inicio.warnings.mock-location.template'),
        title: $filter('translate')('js.controllers.inicio.warnings.mock-location.title'),
        scope: $scope,
        hardwareBackButtonClose: false,
        buttons: [{
          text: $filter('translate')('js.controllers.inicio.warnings.mock-location.button-setting'),
          //type: 'button-positive',
          onTap: function(e) {
            // https://github.com/guyromb/Cordova-open-native-settings
            if (buttonLocked) {
              e.preventDefault();
              return;
            }


            buttonLocked = true;
            cordova.plugins.settings.open("application_development", function() {
              console.log("MOCK 1.S");
            }, function() {
              console.log("MOCK 1.E");
            });

            e.preventDefault();
          }
        }]
      });
    }


    var closePopup = function() {
      if (!myPopup) return;
      myPopup.close();
      myPopup = null;
    }





  })
