angular.module('siggo')
  .controller('Menu', function($scope, $rootScope, $ionicViewSwitcher, $state, $timeout,
    Mensajes, localStorageService, $http, News, Requirements, configuration, $filter) {


    console.warn("app.menu");
    $scope.pendingRequirements = 0;

    //$scope.isPartner = true; // for test


    $scope.noUnreadNews = News.noUnreadNews();
    $scope.$on("count_news", function() {
      console.log('.$on count_news');

      $scope.noUnreadNews = News.noUnreadNews();
    })

    var getReq = function() {

      Requirements.noRequirements().then(function(total) {
        $scope.noRequirements = total;
      }, function(err) {
        $scope.noRequirements = 0;
      });
    };

    $scope.$on("requirements_updated", function() {
      console.log('.$on requirements_updated');
      getReq();
    });

    getReq();

    $scope.goIncome = function() {
      $state.go("app.income");
    }

    $scope.goNews = function() {
      $state.go("app.news");
    }

    $scope.goFileUploader = function() {
      $state.go("app.file-uploader");
    }

    $scope.goAcountStatement = function() {
      $state.go("app.account-statement");
    }

    $scope.goAcountPreferences = function() {
      $state.go("app.account-preferences");
    }

    $scope.openLink = function(link) {
      var url = $filter('translate')(link);
      cordova.InAppBrowser.open(url, "_system");
    }

    $scope.cambiaContrasena = function() {
      Mensajes.confirm("js.controllers.menu.change-password.title", "js.controllers.menu.change-password.text", function() {
        Mensajes.showLoading('js.controllers.menu.change-password.loading');

        $http.post(configuration.http.getUrl() + 'recuperacion', { Correo: $rootScope.Usuario.Correo })
          .success(function(respuesta) {
            Mensajes.hideLoading();
            switch (respuesta.code) {
              case "540": // error en la conexion
                Mensajes.alert('js.controllers.menu.change-password.title', 'common.error-on-server');
                break;
              case "541": // El correo no existe
                Mensajes.alert('js.controllers.menu.change-password.title', 'common.error-on-server');
                break;
              case "543": // Exito
                Mensajes.alert('js.controllers.menu.change-password.title', 'js.controllers.menu.change-password.success', function() {});
                break;
            }
          })
          .error(function() {
            Mensajes.hideLoading();
          })
      })
    }


    $scope.marcaSoporte = function() {
      document.location.href = 'tel:+523318628830';
    }


    $scope.logout = function() {
      $rootScope.$broadcast("cierra_sesion");

      //$rootScope.toggleDrawer();
      /*
      Mensajes.showLoading("Cerrando sesión...");
      localStorageService.set("Usuario", null);
      $timeout(function(){
      	$ionicViewSwitcher.nextDirection('back');
      	$state.go("login");
      	Mensajes.hideLoading();
      }, 1000)
      */
    }


  })
