angular.module('siggo')
  .directive('accountStatementHistory', function() {
    return {
      restrict: 'E',
      link: function(scope, element, attrs) {},
      controller: function($scope, AccountStatement) {
        //$scope.reddit = new Reddit();

        //$scope.busy = true;

        $scope.noMoreItemsAvailable = false;

        $scope.loadMore = function() {
          AccountStatement.getPeriods()
            .then(function(res) {
              $scope.fullPeriods = res;
              $scope.$broadcast('scroll.infiniteScrollComplete');
            }, function(status) {});
        }


        $scope.$on('scroll.account-statement-history.nomore', function() {
          console.log('.$on scroll.account-statement-history.nomore');

          $scope.noMoreItemsAvailable = true;
        });

        $scope.$on('$stateChangeSuccess', function() {
          console.log('.$on $stateChangeSuccess');

          $scope.loadMore();
        });

      },
      templateUrl: 'screens/directives/account-statement-history.html'
    };
  });
