angular.module('siggo')
  .factory('BackButton', function usuarioFactory($rootScope, $ionicPlatform, $state,
    Mensajes, $ionicHistory, $window) {

    // to cancel backbutton of modals
    //  $scope.modal.hardwareBackButtonClose = false;

    // I need ionic ready???
    statesFree = ['login','registro','registro.datos','registro.exitoso','recuperacion']


    $ionicPlatform.registerBackButtonAction(function(event) {

      //si no está en login evita salir
      if (preventIfHasServices(event)) return;

      //si no está en login evota salor
      if (preventIfNotFree(event)) return;

      if ($state.current.name === 'login'){
        navigator.app.exitApp();
      }else{
        $window.history.go(-1);
      }
    }, 100);



    var preventIfHasServices = function(event) {
      if ($rootScope.statusViaje) {
        event.preventDefault();
        Mensajes.alert("js.services.back-button.no-disconnect.title", "js.services.back-button.no-disconnect.text", function() {});
        return true;
      }
      return false;
    }

    var preventIfNotFree = function(event) {
      if (statesFree.indexOf($state.current.name)== -1) {
        console.log('login');
        event.preventDefault();
        Mensajes.confirm("js.services.back-button.disconnect.title", "js.services.back-button.disconnect.text", function() {
          $rootScope.conectar();
          navigator.app.exitApp();
        }, "js.services.back-button.disconnect.btn-power-off", "common.button-cancel");
        return true;
      }
      return false;
    }


    return {}

  })







// http://ionicframework.com/docs/v1/api/service/%24ionicPlatform/
