angular.module('siggo')
  .factory('ServiceCancelModal', function($rootScope, $ionicModal, $log, $timeout,Socket) {

    var _modal = null;
    var template = 'screens/modals/cancelar_viaje.html';
    var $scope = $rootScope.$new(true);
    var dataset = [];
    // $scope.count = 10;


    // var timer;

    // me envia por compativilidad con versiones antiguas
    // data.Codigo;  // nonono
    // data.Descuento; // nonono

    var show = function(data) {
      console.log('ServiceCancelModal', data);
      $scope.Viaje = data;
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
            createModal();
          });
      } else {
        createModal();
      }
      // startTimer();
    }


    var hide = function() {
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
          });
      }
      // $interval.cancel(timer);
    }


    var createModal = function() {
      $ionicModal.fromTemplateUrl(template, {
        scope: $scope,
        animation: 'slide-in-down',
        hardwareBackButtonClose: false
      }).then(function(mod) {
        _modal = mod;
        _modal.show();
      });
    }

    var CancelarViaje = function() {
      Mensajes.showModal("screens/modals/cancelar_viaje.html", "", $scope);
    }

    $scope.Motivos = [{
        Motivo: 'No se presentó el Cliente.'
      },
      {
        Motivo: 'Surgió un imprevisto.'
      },
      {
        Motivo: 'Excedente de Capacidad.'
      },
      {
        Motivo: 'El cliente no está en condiciones.'
      },
      {
        Motivo: 'El cliente no contesta.'
      },
      {
        Motivo: 'Imposible contactar al cliente.'
      }
    ];

    var CancelarViajeManual = function(motivo) {
      console.log(motivo);
      Socket.emit('cancelar_viaje', motivo);
      hide();
    };


    $scope.close = hide;

    $scope.cierraModal = hide;

    $scope.CancelarViaje = CancelarViaje;
    $scope.CancelarViajeManual = CancelarViajeManual;

    return {
      show: show,
      hide: hide
    }
  })
