angular.module('siggo')
  .factory('ServiceInformationModal', function($rootScope, $ionicModal, $log, $timeout) {

    var _modal = null;
    var $scope = $rootScope.$new(true);
    var template = 'screens/modals/solicitudViaje.html';

    var show = function(data, methodPayment) {
      console.log('ServiceInformationModal', [data, methodPayment]);
      $scope.Viaje = data;
      $scope.pagoFormato = methodPayment;
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
            createModal();
          });
      } else {
        createModal();
      }
    }

    var hide = function() {
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
          });
      }
    }

    var createModal = function() {
      $ionicModal.fromTemplateUrl(template, {
        scope: $scope,
        animation: 'slide-in-down',
        hardwareBackButtonClose: false
      }).then(function(mod) {
        _modal = mod;
        _modal.show();
      });
    }


    $scope.close = hide;
    $rootScope.$on('hide', hide);

    $scope.cierraModal = hide;

    return {
      show: show
    }
  })
