window.debug = false;
angular.module('siggo')
  .constant('configuration', {
    Socket: {
      url: 'http://67.222.131.224',
      port: {
        production: 88,
        debug: 97
      },
      route: {
        production: "socket",
        debug: "socket"
      },
      getUrl: function () {
        if (window.debug) return this.url + ':' + this.port.debug + '/' + this.route.debug;
        return this.url + ':' + this.port.production + '/' + this.route.production;
      }
    },
    http: {
      url: 'http://67.222.131.224',
      port: {
        production: 88,
        debug: 97
      },
      getUrl: function () {
        if (window.debug) return this.url + ":" + this.port.debug + "/";
        return this.url + ":" + this.port.production + "/";
      }
    },
    httpServices: function () {
      if (window.debug) return 'http://siggo.com.mx:91/';
      return 'https://siggo.com.mx:96/';
    }(),
    apiKey: function () {
      if (window.debug) return 'AIzaSyCFUMi_y2RCLmEfnJW5JRDmYLm4bKf0oEc';
      return 'AIzaSyDXPo8jP-1M5MDoPv-49W_BwoA8YzKgaKI';
    }(),
    timeouts: {},
    timers: {
      timeoutWaitToReloadApp: 30000
    }
  });