angular.module('siggo')
  .controller('IncomeCtrl', function($scope, $rootScope, Mensajes, Socket, $state,
    localStorageService, Income) {

    $scope.period = 0;
    $scope.siguiente = false;

    $scope.incomeReport;
    $scope.selectedTab = 0;


    $scope.previousPeriod = function() {
      $scope.period--;
      getPeriod();
    }

    $scope.nextPeriod = function() {
      $scope.period++;
      getPeriod();
    }

    var getPeriod = function() {
      console.log($scope.period);
      Mensajes.showLoading('js.controllers.income.loading');

      Income.getPeriod($scope.period)
        .then(function(res) {
          //$scope.places = res;
          $scope.incomeReport = res;

          //$scope.gananciasObtenidas(res);
          $scope.siguiente = $scope.period < 0 ? true : false;
          Mensajes.hideLoading();
          console.log('Period', res);
          console.log('Period', res.detalles.peticiones.rechazadas);

        }, function(status) {
          //$scope.loginError = status;
          //directiva de reload ????
          Mensajes.hideLoading();
        });
    }


    $scope.$on('$ionicView.afterEnter', function() {
      console.log('.$on afterEnter income');

      getPeriod();
    });


  })
