angular.module('siggo')
    .controller('NewsCtrl', function($scope, Mensajes, $state, $ionicViewSwitcher, News, $rootScope) {


        $scope.news = [];


        $scope.$on('$ionicView.afterEnter', function() {
          console.log('.$on afterEnter news');

            $scope.news = News.getLocalNews();
            News.getNews().then(function(res) {
                $scope.noticias = res;
            }, function(status) {

            });
        })

        $scope.$on('$ionicView.beforeEnter', function() {
          console.log('.$on beforeEnter news');

            News.newsReaded();
        })

        $scope.$on('$ionicView.beforeLeave', function() {
          console.log('.$on beforeLeave news');

            News.newsReaded();
        })



        $scope.delete = function(item) {
            News.deleteNew(item);
            $scope.news = News.news;
        }

        $scope.Cerrar = function() {
            $state.go('app.inicio');
        }

        $scope.goToState = function(state) {
            $state.go(state);
        }

        $scope.goToLink = function(url) {
            if (window.cordova) {
                cordova.InAppBrowser.open(url, "_system");
            } else {
                window.open(url, '_blank', 'location=yes,height=570,width=520,scrollbars=yes,status=yes');
            }
        }


    })
