angular.module('siggo')
.controller('Recuperacion', function($scope, Mensajes, $http, $ionicViewSwitcher,
	$state, $rootScope, configuration) {

	$scope.Recuperacion = {
		Correo: ""
	}

	$scope.recuperacion = function() {


		if ($scope.Recuperacion.Correo) {
			Mensajes.showLoading('js.controllers.recuperacion.loading');
			
			$http.post(configuration.http.getUrl()+'recuperacion', $scope.Recuperacion)
			.success(function(respuesta) {
				Mensajes.hideLoading();
				switch (respuesta.code) {
					case "540": // error en la conexion
						Mensajes.alert('js.controllers.recuperacion.title', 'common.error-on-server');
						break;
					case "541": // El correo no existe
						Mensajes.alert('js.controllers.recuperacion.title', 'js.controllers.recuperacion.error');
						break;
					case "543": // Exito
						Mensajes.alert('js.controllers.recuperacion.title', 'js.controllers.recuperacion.success',function(){
							$ionicViewSwitcher.nextDirection('back');
							$state.go('login');
						});
						break;
				}
			})
			.error(function(){
				Mensajes.hideLoading();
			})
		} else {
			Mensajes.hideLoading(); // borrar. hideLoading sin previo showLoading
			Mensajes.alert('js.controllers.recuperacion.title', 'js.controllers.recuperacion.invalid');
		}
	};

})
