angular.module('siggo')
.directive('accountStatementSummary', function() {
  return {
  	restrict: 'E',
    link: function (scope, element, attrs) { },
    controller: function($scope, AccountStatement ) {

		$scope.period = 0;
		$scope.siguiente = false;
		

		$scope.previousPeriod = function() {
			$scope.period--;
			getSummary();
		}

		$scope.nextPeriod = function() {
			$scope.period++;
			getSummary();
		}



		var getSummary = function(){
			AccountStatement.getSummary($scope.period)
			.then(function(res) {
				console.log(res);
				$scope.summaryInfo = res;
	          	$scope.siguiente = $scope.period < 0 ? true : false;

				//Mensajes.hideLoading();
			}, function(status) {
				//$scope.loginError = status;
				//directiva de reload ????
				//Mensajes.hideLoading();
			});
		}
		getSummary();
	},
    templateUrl: 'screens/directives/account-statement-summary.html'
  };
});


