angular.module('siggo')
.directive('takePicture', function() {
  return {
  	restrict: 'E',
    scope: {
        picture: "=",
        backPicture:"=",
        cameraIcon:"="
    },
    link: function (scope, element, attrs) {
        //scope.value = Service.get();
    },
	controller: function($scope, $element) {
        //$scope.picture;
        //$scope.backPicture = "img/take-picture/tarjeta-conekta.png";

        var cameraOptions = {
            encodingType: 0,
            quality:50,
            //allowEdit:true,
            targetWidth:500,
            destinationType: 0,
            correctOrientation: true
        };

        //console.log("cameraIcon",$scope.cameraIcon);
        var cameraStarted = false;


        $scope.takePicture = function(){
            if ( cameraStarted ) return;

            try{
                navigator.camera.getPicture(cameraSuccess, cameraError, cameraOptions);
                cameraStarted = true;
            }catch(e){
                console.log("Necesario dispositivo movil para ejecutar\n", e);
            }
            //return false;
        }

        var cameraSuccess = function(data){
            cameraStarted = false;

            console.log("take picture Success, ");
            $scope.picture = "data:image/jpeg;base64," + data;
            //$scope.picture = data;
            $scope.$apply();

            //return false;
        }

        var cameraError = function(error){
            cameraStarted = false;

            console.error("take picture error, ", error);
            //return false;
        }


	},

    templateUrl: 'screens/directives/take-picture.html'
  };
});


/*

$scope.CambiarCategoria=function(C){
    $scope.Categoria=C
}


<div ng-class="Categoria==2? 'autos-item-select-pink' : 'autos-item'">
    <a ng-click="CambiarCategoria(2)">
        <img src="img/autos/2.png">
        <p>Pink</p>
    </a>
</div>
<div ng-class="Categoria==1? 'autos-item-select' : 'autos-item'">
    <a ng-click="CambiarCategoria(1)">
        <img src="img/autos/1.png">
        <p>Classic</p>
    </a>
</div>
<div ng-class="Categoria==4? 'autos-item-select' : 'autos-item'">
    <a ng-click="CambiarCategoria(4)">
        <img src="img/autos/4.png">
        <p>Executive</p>
    </a>
</div>
<div ng-class="Categoria==6? 'autos-item-select' : 'autos-item'">
    <a ng-click="CambiarCategoria(6)">
        <img src="img/autos/6.png">
        <p>Passenger</p>
    </a>
</div>


*/
