angular.module('siggo')
    .factory('LoadTester', function(uiGmapGoogleMapApi, $ionicPlatform, $timeout, configuration,
       Mensajes) {

        var ionicready = false;
        var googlemaps = false;


        // hay que poner todas
            // var conekta = false;
            // var socket = false;
            // var facebook = false;


        var timeout = $timeout( function() {
            if (!ionicready || !googlemaps){

                if (navigator.splashscreen) navigator.splashscreen.hide();

                Mensajes.alert("js.services.load-tester.title", "js.services.load-tester.text", function() {
                    restart();
                });
            }
        }, configuration.timers.timeoutWaitToReloadApp);


        $ionicPlatform.ready(function(){

            ionicready = true;
        });


        uiGmapGoogleMapApi.then(function(maps) {
            console.log('API G: MapJs');
            googlemaps = true;
        })



        var restart = function(){
            // detenertimeout
            window.location.reload();
            if (navigator.splashscreen) navigator.splashscreen.show();

        }



        return {
            isReady: function(){ return ionicready && googlemaps}
        }

    })
