angular.module('siggo')
  .factory('LoadingModal', function($ionicModal,
    $state, $rootScope, $ionicViewSwitcher, Usuario,PushManager,
    LoadTester, Requirements, UserPreferences, $timeout,configuration,Socket
  ) {

    var _modal = null;
    var template = 'screens/modals/cargar.html';
    var $scope = $rootScope.$new(true);
    // $scope.count = 10;


    // var timer;

    // me envia por compativilidad con versiones antiguas
    // data.Codigo;  // nonono
    // data.Descuento; // nonono

    if (navigator.splashscreen) navigator.splashscreen.hide();

    var show = function() {
      console.log('LoadingModal');
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
            createModal();
          });
      } else {
        createModal();
      }
      // startTimer();
    }


    var hide = function() {
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
          });
      }
      // $interval.cancel(timer);
    }


    var createModal = function() {
      $ionicModal.fromTemplateUrl(template, {
        scope: $scope,
        animation: 'slide-in-down',
        hardwareBackButtonClose: false
      }).then(function(mod) {
        _modal = mod;
        _modal.show();
      });
    }

    /* if (window.cordova && !window.debug && deviceConfiguration.platform == "android") {
       document.addEventListener('deviceready', function() {
         console.log("deviceready");

         load();
         // second requirement

       });
     } else {
       console.log("pc deviceready");
       $timeout(load, 1);
     }*/
    var mapaStart = function() {
      if (window.cordova) {
        document.addEventListener('deviceready', function() {
          PushManager.registra();
          var bgGeo = window.BackgroundGeolocation;
          bgGeo.start();
          setTimeout(function(){
            bgGeo.stop();
          },250);
        });
      }
    }

    var loader = function() {
      LoadTester.isReady();
      if (Usuario.get()) readPreferences();
    }

    mapaStart();

    $scope.$on('loading-modal', loader);

    var x = 0;

    var readPreferences = function() {
      console.log("readPreferences");
      UserPreferences.read().then(function(data) {
        goUse();
      }, function(status) {
        if (x > 10) { // teen oportunities for get preferences
          $timeout(goUse, 250);
          x = 0;
          return;
        }
        readPreferences();
        x++;
      });
    };

    var goUse = function() {
      console.log("goUse");
      Requirements.noRequirements().then(function() {
        console.log("aqui");
        $state.go('file-uploader');
        hide();
      }, function(err) {
        console.log("aqui");
        $state.go('app.inicio');
        setTimeout(hide,3000);
      });
    };

    $rootScope.$on('$ionicView.afterEnter', function() {
      console.log($state.current.name);
      if ($state.current.name == 'login') loader();
    });

    $scope.cierraModal = hide;





    return {
      show: show
    }
  });
