angular.module('siggo')
  .factory('VehiclesListModal', function($rootScope, $ionicModal, $log, $timeout, User) {

    var _modal = null;
    var template = 'screens/modals/vehiculos.html';
    var $scope = $rootScope.$new(true);
    var dataset = [];
    // $scope.count = 10;


    // var timer;

    // me envia por compativilidad con versiones antiguas
    // data.Codigo;  // nonono
    // data.Descuento; // nonono

    var show = function(data) {
      console.log('VehiclesListModal', data);
      $scope.viaje = data;
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
            createModal();
          });
      } else {
        createModal();
      }
      // startTimer();
    }


    var hide = function() {
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
          });
      }
      // $interval.cancel(timer);
    }

    var vehicleSelected = function(vehicle) {
      User.connectVehicle(vehicle.IdVehiculo, vehicle.Categoria).then(function(res) {
        $rootScope.vehicleOnline = true;
        hide();
        if (window.cordova)
          BackgroundGeolocation.start();
    }, function(status) {
        hide();
      });
    }

    var createModal = function() {
      $ionicModal.fromTemplateUrl(template, {
        scope: $scope,
        animation: 'slide-in-down',
        hardwareBackButtonClose: false
      }).then(function(mod) {
        _modal = mod;
        User.getVehiclesList().then(function(data) {
          $scope.dataset = data;
          _modal.show();
        }, function(err) {
          hide();
        });
      });
    }


    $scope.close = hide;

    $scope.vehicleSelected = vehicleSelected;

    $scope.cierraModal = hide;

    return {
      show: show,
      hide: hide
    }
  })
