angular.module('siggo')
  .factory('Push', function($rootScope, $cordovaPush, Socket, deviceConfiguration,
    $ionicViewSwitcher, $state, $cordovaVibration, $$flashlight, AccountPreferences) {

    var iosConfig = {
      "badge": true,
      "sound": true,
      "alert": true,
    };
    //477591987925
    var androidConfig = {
      "senderID": "901891709285",
    };
    var registra = function(token) {
      Socket.on("cliente_registra_push", registroCompletado);
      Socket.emit("cliente_registra_push", { Token: token, SO: deviceConfiguration.platform })
    }
    var registroCompletado = function(data) {
      console.log('.on cliente_registra_push');
        if (!data.Error) {
          Socket.off("cliente_registra_push", registroCompletado);
          $rootScope.Usuario.Registro = data.Token;
        } else {
          $timeout(function() {
            registra(data.Token);
          }, 1000);
        }
      }

    $rootScope.$on('$cordovaPush:notificationReceived', function(event, notificacion) {
      console.log('.$on rootScope $cordovaPush:notificationReceived');

      //Arreglo para evitar bloqueo en peticion desde otro State
      if ($state.current.name != "app.inicio") {
        try {
          $rootScope.panelSocio.close();
          $rootScope.panelSocio = null;
        } catch (err) {}

        $ionicViewSwitcher.nextDirection('back');
        $state.go("app.inicio");
      }


      switch (notificacion.event) {
        case 'registered':
          if (notificacion.regid.length > 0) registra(notificacion.regid);
          break;
        case 'message':

          if (notificacion.foreground) { /*frente*/ } else { /*back*/ }

          var accessibility = AccountPreferences.localAccessibility();
          if (!accessibility) return;
          if (window.cordova && accessibility.deaf) {
            //$cordovaVibration.vibrate([300, 150, 300, 150, 300, 150, 300, 150, 300]);
            //$$flashlight.flash([300, 150, 300, 150, 300, 150, 300, 150, 300]);
            $cordovaVibration.vibrate(500);
            $$flashlight.flash(500);
          }
          break;
      }
    })
    return {
      registra: function(state) {
        if (state) {
          if (window.cordova)
            switch (deviceConfiguration.platform) {
              case "android":
                $cordovaPush.register(androidConfig).then(function(result) {});
                break;
              case "ios":
                $cordovaPush.register(iosConfig).then(registra)
                break;
            }
          else registra("")
        } else {
          if (window.cordova)
            $cordovaPush.unregister().then(function(result) {
              registra("");
            }, function(err) {
              registra("");
            });
        }

        return true;
      },
    }
  })
