"use strict";

angular.module('siggo')
  .factory('Emergency', function($http, $q, $rootScope, configuration) {


    var post = {
      method: 'POST',
      url: configuration.http.getUrl(),
      headers: {
        'Content-Type': 'application/json'
      },
      data: {},
      timeout: 15000
    };

    var alarmActived = false;

    var send = function() {
      var _post = angular.copy(post);
      _post.url += "emergency";
      //_post.data = {period: period};
      _post.headers.accessToken = $rootScope.Usuario.Token;

      return $http(_post)
        .then(function(res) {
          //console.log(res);
          if (typeof res.data === 'object') {
            alarmActived=true;
            return res.data;
          } else {
            return $q.reject(500);
          }
        }, function(err) {
          if (err.status == 511) {
            console.log(err);
          }
          // crear directiva para cuando no está autorizado o redireccionar a loguin ???
          // me agradaria servicio que pase como parametro la ruta actual a loguin
          console.info(err);
          return $q.reject(err.status);
        });
    };

    return {
      send: send,
      alarmActived: alarmActived
    };
  })
