angular.module('siggo')
  .factory('MessengerFeedback', function(
    localStorageService, $q, $http, $rootScope, Socket, configuration) {

    var request = {
      method: 'POST',
      url: configuration.http.getUrl() + "driver/messenger-feedback/",
      headers: {
        'Content-Type': 'application/json',
        accessToken: ""
      },
      data: {},
      timeout: 15000
    }


    var post = function(val) {
      var _request = angular.copy(request);
      //_request.url += "get/new";
      _request.data = val;
      _request.headers.accessToken = localStorageService.get("Usuario").Token;

      return $http(_request)
        .then(function(res) {
          //console.log(res);
          if (typeof res.data === 'object') {


            for (var id in res.data) {
              var obj = angular.extend(res.data[id], {
                newViewed: false
              });
              _news.push(obj);
            }

            //angular.extend(_news, res.data);
            //_news.extend(res);

            localStorageService.set("news", _news);
            $rootScope.$broadcast('count_news');


            return _news;
          } else {
            return $q.reject(500);
          }
        }, function(err) {
          if (err.status == 511) console.log(err);
          // crear directiva para cuando no está autorizado o redireccionar a loguin ???
          // me agradaria servicio que pase como parametro la ruta actual a loguin

          console.info(err);
          return $q.reject(err.status);
        });
    }







    return {
      create: post
    }



  });
