angular.module('siggo')
    .factory('Requests', function(localStorageService, $q, $http, $rootScope, Socket, configuration) {

        var post = {
            method: 'POST',
            url: configuration.http.getUrl()+"requests/",
            headers: {
                'Content-Type': 'application/json',
                accessToken: ""
            },
            data: { },
            timeout: 15000
        }



        var self = function() {
            var _post = angular.copy(post);
            _post.url += "self";
            //_post.data = requestConfiguration;
            //_post.headers.accessToken = Usuario.get().Token;
            _post.headers.accessToken = localStorageService.get("Usuario").Token;

            return $http(_post)
            .then(function(res){
              //console.log(res);
              if (typeof res.data === 'object'){

                return res.data;
              }else{
                return $q.reject(500);
              }
            },function(err){
              if (err.status == 511) console.log(err);
              // crear directiva para cuando no está autorizado o redireccionar a loguin ???
              // me agradaria servicio que pase como parametro la ruta actual a loguin

              console.info(err);
              return $q.reject(err.status);
            });
        }


        return {
            self: self
        }

    });
