angular.module('siggo')
    .factory('Services', function(localStorageService, $q, $http, $rootScope, Socket, configuration) {

        var post = {
            method: '',
            url: configuration.http.getUrl()+"driver/services",
            headers: {
                'Content-Type': 'application/json',
                accessToken: ""
            },
            data: { },
            timeout: 15000
        }




        var sendComment = function(idService, comments) {
            var _post = angular.copy(post);
            _post.method += "put";
            _post.url += "/" + idService;
            _post.data.ComentariosUsuario = comments;
            _post.headers.accessToken = localStorageService.get("Usuario").Token;

            return $http(_post)
            .then(function(res){
              console.log(res);
              if (typeof res.data === 'object'){

                return res.data;
              }else{
                return $q.reject(500);
              }
            },function(err){
              if (err.status == 511) console.log(err);
              // crear directiva para cuando no está autorizado o redireccionar a loguin ???
              // me agradaria servicio que pase como parametro la ruta actual a loguin

              console.info(err);
              return $q.reject(err.status);
            });
        }

        var current = function(idService, comments) {
            var _post = angular.copy(post);
            _post.method += "get";
            _post.url += "/current";
            _post.headers.accessToken = localStorageService.get("Usuario").Token;

            return $http(_post)
            .then(function(res){
              console.log(res);
              if (typeof res.data === 'object'){

                return res.data;
              }else{
                return $q.reject(500);
              }
            },function(err){
              if (err.status == 511) console.log(err);
              // crear directiva para cuando no está autorizado o redireccionar a loguin ???
              // me agradaria servicio que pase como parametro la ruta actual a loguin

              console.info(err);
              return $q.reject(err.status);
            });
        }



        return {
            sendComment: sendComment,
            current: current
        }



    });
